diff -ruN vdr-1.7.0/tools.h vdr-1.7.1/tools.h
--- vdr-1.7.0/tools.h	2008-02-17 14:41:27.000000000 +0100
+++ vdr-1.7.1/tools.h	2008-05-22 12:26:57.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 2.0 2008/02/17 13:41:27 kls Exp $
+ * $Id: tools.h 2.1 2008/05/22 10:26:57 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -136,7 +136,7 @@
      ///< If ToCode is NULL, "UTF-8" is used.
   ~cCharSetConv();
   const char *Convert(const char *From, char *To = NULL, size_t ToLength = 0);
-     ///< Converts the given Text from FromCode to ToCode (as set in the cosntructor).
+     ///< Converts the given Text from FromCode to ToCode (as set in the constructor).
      ///< If To is given, it is used to copy at most ToLength bytes of the result
      ///< (including the terminating 0) into that buffer. If To is not given,
      ///< the result is copied into a dynamically allocated buffer and is valid as
diff -ruN vdr-1.7.0/transfer.c vdr-1.7.1/transfer.c
--- vdr-1.7.0/transfer.c	2007-01-05 11:45:28.000000000 +0100
+++ vdr-1.7.1/transfer.c	2008-08-15 16:32:12.000000000 +0200
@@ -4,109 +4,52 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.c 2.0 2007/01/05 10:45:28 kls Exp $
+ * $Id: transfer.c 2.1 2008/08/15 14:32:12 kls Exp $
  */
 
 #include "transfer.h"
 
-#define TRANSFERBUFSIZE  MEGABYTE(2)
-#define POLLTIMEOUTS_BEFORE_DEVICECLEAR 6
-
 // --- cTransfer -------------------------------------------------------------
 
 cTransfer::cTransfer(tChannelID ChannelID, int VPid, const int *APids, const int *DPids, const int *SPids)
 :cReceiver(ChannelID, -1, VPid, APids, Setup.UseDolbyDigital ? DPids : NULL, SPids)
-,cThread("transfer")
 {
-  ringBuffer = new cRingBufferLinear(TRANSFERBUFSIZE, TS_SIZE * 2, true, "Transfer");
-  remux = new cRemux(VPid, APids, Setup.UseDolbyDigital ? DPids : NULL, SPids);
+  patPmtGenerator.GeneratePmt(ChannelID);
 }
 
 cTransfer::~cTransfer()
 {
   cReceiver::Detach();
   cPlayer::Detach();
-  delete remux;
-  delete ringBuffer;
 }
 
 void cTransfer::Activate(bool On)
 {
-  if (On)
-     Start();
-  else {
-     Cancel(3);
-     cPlayer::Detach();
+  if (On) {
+     PlayTs(patPmtGenerator.GetPat(), TS_SIZE);
+     int Index = 0;
+     while (uchar *pmt = patPmtGenerator.GetPmt(Index))
+           PlayTs(pmt, TS_SIZE);
      }
 }
 
 void cTransfer::Receive(uchar *Data, int Length)
 {
-  if (cPlayer::IsAttached() && Running()) {
-     int p = ringBuffer->Put(Data, Length);
-     if (p != Length && Running())
-        ringBuffer->ReportOverflow(Length - p);
+  if (cPlayer::IsAttached()) {
+     // Transfer Mode means "live tv", so there's no point in doing any additional
+     // buffering here. The TS packets *must* get through here! However, every
+     // now and then there may be conditions where the packet just can't be
+     // handled when offered the first time, so that's why we try several times:
+     for (int i = 0; i < 100; i++) {
+         if (PlayTs(Data, Length) > 0)
+            return;
+         fprintf(stderr, "-");//XXX just for testing - remove when stable
+         cCondWait::SleepMs(10);
+         }
+     esyslog("ERROR: TS packet not accepted in Transfer Mode");
      }
 }
 
-void cTransfer::Action(void)
-{
-  int PollTimeouts = 0;
-  uchar *p = NULL;
-  int Result = 0;
-  while (Running()) {
-        int Count;
-        uchar *b = ringBuffer->Get(Count);
-        if (b) {
-           if (ringBuffer->Available() > TRANSFERBUFSIZE * 9 / 10) {
-              // If the buffer runs full, we have no chance of ever catching up
-              // since the data comes in at the same rate as it goes out (it's "live").
-              // So let's clear the buffer instead of suffering from permanent
-              // overflows.
-              dsyslog("clearing transfer buffer to avoid overflows");
-              DeviceClear();
-              ringBuffer->Clear();
-              remux->Clear();
-              PlayPes(NULL, 0);
-              p = NULL;
-              continue;
-              }
-           Count = remux->Put(b, Count);
-           if (Count)
-              ringBuffer->Del(Count);
-           }
-        if (!p)
-           p = remux->Get(Result);
-        if (p) {
-           cPoller Poller;
-           if (DevicePoll(Poller, 100)) {
-              PollTimeouts = 0;
-              int w = PlayPes(p, Result);
-              if (w > 0) {
-                 p += w;
-                 Result -= w;
-                 remux->Del(w);
-                 if (Result <= 0)
-                    p = NULL;
-                 }
-              else if (w < 0 && FATALERRNO)
-                 LOG_ERROR;
-              }
-           else {
-              PollTimeouts++;
-              if (PollTimeouts == POLLTIMEOUTS_BEFORE_DEVICECLEAR) {
-                 dsyslog("clearing device because of consecutive poll timeouts");
-                 DeviceClear();
-                 ringBuffer->Clear();
-                 remux->Clear();
-                 PlayPes(NULL, 0);
-                 p = NULL;
-                 }
-              }
-           }
-        }
-}
-
 // --- cTransferControl ------------------------------------------------------
 
 cDevice *cTransferControl::receiverDevice = NULL;
diff -ruN vdr-1.7.0/transfer.h vdr-1.7.1/transfer.h
--- vdr-1.7.0/transfer.h	2007-01-05 11:45:45.000000000 +0100
+++ vdr-1.7.1/transfer.h	2008-05-25 14:44:49.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.h 2.0 2007/01/05 10:45:45 kls Exp $
+ * $Id: transfer.h 2.1 2008/05/25 12:44:49 kls Exp $
  */
 
 #ifndef __TRANSFER_H
@@ -13,17 +13,13 @@
 #include "player.h"
 #include "receiver.h"
 #include "remux.h"
-#include "ringbuffer.h"
-#include "thread.h"
 
-class cTransfer : public cReceiver, public cPlayer, public cThread {
+class cTransfer : public cReceiver, public cPlayer {
 private:
-  cRingBufferLinear *ringBuffer;
-  cRemux *remux;
+  cPatPmtGenerator patPmtGenerator;
 protected:
   virtual void Activate(bool On);
   virtual void Receive(uchar *Data, int Length);
-  virtual void Action(void);
 public:
   cTransfer(tChannelID ChannelID, int VPid, const int *APids, const int *DPids, const int *SPids);
   virtual ~cTransfer();
diff -ruN vdr-1.7.0/vdr.c vdr-1.7.1/vdr.c
--- vdr-1.7.0/vdr.c	2008-03-14 14:22:39.000000000 +0100
+++ vdr-1.7.1/vdr.c	2008-09-06 16:08:44.000000000 +0200
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 2.0 2008/03/14 13:22:39 kls Exp $
+ * $Id: vdr.c 2.3 2008/09/06 14:08:44 kls Exp $
  */
 
 #include <getopt.h>
@@ -141,7 +141,6 @@
 
 static void SignalHandler(int signum)
 {
-  isyslog("caught signal %d", signum);
   switch (signum) {
     case SIGPIPE:
          break;
@@ -210,9 +209,6 @@
 #elif defined(REMOTE_RCU)
   RcuDevice = RCU_DEVICE;
 #endif
-#if defined(VFAT)
-  VfatFileSystem = true;
-#endif
 #if defined(VDR_USER)
   VdrUser = VDR_USER;
 #endif
@@ -563,17 +559,15 @@
   cThemes::SetThemesDirectory(AddDirectory(ConfigDirectory, "themes"));
 
   Setup.Load(AddDirectory(ConfigDirectory, "setup.conf"));
-  if (!(Sources.Load(AddDirectory(ConfigDirectory, "sources.conf"), true, true) &&
-        Diseqcs.Load(AddDirectory(ConfigDirectory, "diseqc.conf"), true, Setup.DiSEqC) &&
-        Channels.Load(AddDirectory(ConfigDirectory, "channels.conf"), false, true) &&
-        Timers.Load(AddDirectory(ConfigDirectory, "timers.conf")) &&
-        Commands.Load(AddDirectory(ConfigDirectory, "commands.conf"), true) &&
-        RecordingCommands.Load(AddDirectory(ConfigDirectory, "reccmds.conf"), true) &&
-        SVDRPhosts.Load(AddDirectory(ConfigDirectory, "svdrphosts.conf"), true) &&
-        Keys.Load(AddDirectory(ConfigDirectory, "remote.conf")) &&
-        KeyMacros.Load(AddDirectory(ConfigDirectory, "keymacros.conf"), true)
-        ))
-     EXIT(2);
+  Sources.Load(AddDirectory(ConfigDirectory, "sources.conf"), true, true);
+  Diseqcs.Load(AddDirectory(ConfigDirectory, "diseqc.conf"), true, Setup.DiSEqC);
+  Channels.Load(AddDirectory(ConfigDirectory, "channels.conf"), false, true);
+  Timers.Load(AddDirectory(ConfigDirectory, "timers.conf"));
+  Commands.Load(AddDirectory(ConfigDirectory, "commands.conf"), true);
+  RecordingCommands.Load(AddDirectory(ConfigDirectory, "reccmds.conf"), true);
+  SVDRPhosts.Load(AddDirectory(ConfigDirectory, "svdrphosts.conf"), true);
+  Keys.Load(AddDirectory(ConfigDirectory, "remote.conf"));
+  KeyMacros.Load(AddDirectory(ConfigDirectory, "keymacros.conf"), true);
 
   if (!*cFont::GetFontFileName(Setup.FontOsd)) {
      const char *msg = "no fonts available - OSD will not show any text!";
@@ -1288,9 +1282,11 @@
   ReportEpgBugFixStats();
   if (WatchdogTimeout > 0)
      dsyslog("max. latency time %d seconds", MaxLatencyTime);
-  isyslog("exiting, exit code %d", ShutdownHandler.GetExitCode());
+  if (LastSignal)
+     isyslog("caught signal %d", LastSignal);
   if (ShutdownHandler.EmergencyExitRequested())
      esyslog("emergency exit!");
+  isyslog("exiting, exit code %d", ShutdownHandler.GetExitCode());
   if (SysLogLevel > 0)
      closelog();
   if (HasStdin)
